//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
   EnumResolution();
}

__fastcall TForm1::~TForm1()
{
}

void __fastcall TForm1::EnumResolution(void)
{
   DEVMODE dmResolution;
   int iCurrentMode=ENUM_CURRENT_SETTINGS;
   int iCurWidth=0;
   int iCurHeight=0;
   int iCurBitsPixel=0;
   int iCurFrequency=0;
   AnsiString szResolution;
   int iIndex=0;

   ZeroMemory(&dmResolution, sizeof(DEVMODE));
   EnumDisplaySettings(NULL, iCurrentMode, &dmResolution);
   iCurWidth=dmResolution.dmPelsWidth;
   iCurHeight=dmResolution.dmPelsHeight;
   iCurBitsPixel=dmResolution.dmBitsPerPel;
   iCurFrequency=dmResolution.dmDisplayFrequency;

   iCurrentMode=0;
   ZeroMemory(&dmResolution, sizeof(DEVMODE));
   ComboBox1->Items->Clear();
   while(EnumDisplaySettings(NULL, iCurrentMode++, &dmResolution))
   {
      szResolution=IntToStr(dmResolution.dmPelsWidth)+"x"+
         IntToStr(dmResolution.dmPelsHeight)+", "+
         IntToStr(dmResolution.dmBitsPerPel)+" Bits, "+
         IntToStr(dmResolution.dmDisplayFrequency)+" Hz";
      ComboBox1->Items->Add(szResolution);
      if(dmResolution.dmPelsWidth==(DWORD)iCurWidth &&
         dmResolution.dmPelsHeight==(DWORD)iCurHeight &&
         dmResolution.dmBitsPerPel==(DWORD)iCurBitsPixel &&
         dmResolution.dmDisplayFrequency==(DWORD)iCurFrequency)
      {
         ComboBox1->ItemIndex=iIndex;
      }
      iIndex++;
      ZeroMemory(&dmResolution, sizeof(DEVMODE));
   }
}

void __fastcall TForm1::ChangeResolution(void)
{
   DEVMODE dmResolution;
   ZeroMemory(&dmResolution, sizeof(DEVMODE));
   int iCurrentMode=0;
   int iResult=DISP_CHANGE_BADMODE;
   AnsiString szResolution;

   while(EnumDisplaySettings(NULL, iCurrentMode++, &dmResolution))
   {
      szResolution=IntToStr(dmResolution.dmPelsWidth)+"x"+
         IntToStr(dmResolution.dmPelsHeight)+", "+
         IntToStr(dmResolution.dmBitsPerPel)+" Bits, "+
         IntToStr(dmResolution.dmDisplayFrequency)+" Hz";
      if(ComboBox1->Items->Strings[ComboBox1->ItemIndex]==szResolution)
      {
         dmResolution.dmFields=DM_PELSWIDTH | DM_PELSHEIGHT |
            DM_BITSPERPEL | DM_DISPLAYFREQUENCY;
         iResult=ChangeDisplaySettings(&dmResolution, CDS_TEST);
         if(iResult==DISP_CHANGE_SUCCESSFUL)
         {
            ChangeDisplaySettings(&dmResolution, CDS_UPDATEREGISTRY);
         }
         break;
      }
   }
}

void __fastcall TForm1::Button1Click(TObject *Sender)
{
   ChangeResolution();
}

